From c45b6766f57c9c586919fc6f6dc217d5a864c8a5 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 02 2021 08:46:05 +0000
Subject: [PATCH 1957/2232] Merge pull request #637 from dtolnay/msvc


MSVC workaround for "C linkage function cannot return C++ class"
---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index ff63f9f..5b67e09 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -119,6 +119,22 @@ fn write_data_structures<'a>(out: &mut OutFile<'a>, apis: &'a [Api]) {
         }
     }
 
+    out.set_namespace(Default::default());
+
+    out.next_section();
+    for ty in out.types {
+        // MSVC workaround for "C linkage function cannot return C++ class"
+        // error. Apparently the compiler fails to perform implicit
+        // instantiations as part of an extern declaration. Instead we
+        // instantiate explicitly.
+        // See https://stackoverflow.com/a/57429504/6086311.
+        if let Type::SliceRef(_) = ty {
+            write!(out, "template struct ");
+            write_type(out, ty);
+            writeln!(out, ";");
+        }
+    }
+
     out.next_section();
     for api in apis {
         if let Api::TypeAlias(ety) = api {
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 827acc6..3841cb2 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -828,13 +828,6 @@ std::unique_ptr<I> ns_c_return_unique_ptr_ns() {
 // > definition) of each of its non-inherited non-template members that has not
 // > been previously explicitly specialized in the translation unit.
 template struct rust::Box<tests::Shared>;
-template struct rust::Slice<const char>;
-template struct rust::Slice<const uint8_t>;
-template struct rust::Slice<uint8_t>;
-template struct rust::Slice<const tests::Shared>;
-template struct rust::Slice<tests::Shared>;
-template struct rust::Slice<const tests::R>;
-template struct rust::Slice<tests::R>;
 template struct rust::Vec<uint8_t>;
 template struct rust::Vec<rust::String>;
 template struct rust::Vec<tests::Shared>;

